local bBars = CreateFrame('frame', 'bBars', UIParent)

local addonName, ns = ...
bBars.config = false
bBars.frames = {}

bBars.default_positions = {
	['bMultiBar1'] = 				{ a = 'BOTTOM', p = 'UIParent', pa = 'BOTTOM', x = 0, y = 0, col = 12, hide = 0 },
	['bMultiBar2'] = 				{ a = 'CENTER', p = 'UIParent', pa = 'CENTER', x = 0, y = 0, col = 12, hide = 1 },
	['bMultiBar3'] = 				{ a = 'RIGHT', p = 'UIParent', pa = 'RIGHT', x = 0, y = 0, col = 1, hide = 0 },
	['bMultiBar4'] = 				{ a = 'RIGHT', p = 'bMultiBar3', pa = 'LEFT', x = 0, y = 0, col = 1, hide = 0 },
	['bMultiBar5'] = 				{ a = 'BOTTOM', p = 'bMultiBar1', pa = 'TOP', x = 0, y = 0, col = 12, hide = 0 },
	['bMultiBar6'] = 				{ a = 'BOTTOM', p = 'bMultiBar5', pa = 'TOP', x = 0, y = 0, col = 12, hide = 0 },
	['bMultiBar7'] = 				{ a = 'TOP', p = 'bMultiBar2', pa = 'BOTTOM', x = 0, y = 0, col = 12, hide = 1 },
	['bShapeshiftFrame'] = 			{ a = 'BOTTOMLEFT', p = 'bMultiBar6', pa = 'TOPLEFT', x = 0, y = 0, col = 12, hide = 0, size = 25, gap = 3 },
	
	['bPetFrame'] = 				{ a = 'BOTTOMLEFT', p = 'bMultiBar6', pa = 'TOPLEFT', x = 0, y = 0, col = 12, hide = 0, size = 25, gap = 3 },
	['MultiCastActionBarFrame'] = 	{ a = 'BOTTOM', p = 'bMultiBar6', pa = 'TOP', x = 0, y = 0, col = 12, hide = 0 },
	['bMicroMenuFrame'] = 			{ a = 'LEFT', p = 'bMultiBar1', pa = 'RIGHT', x = 0, y = 0, col = 12, hide = 0, size = 16, gap = 4, col = 6 },
	['bBagsFrame'] = 				{ a = 'BOTTOMLEFT', p = 'bMicroMenuFrame', pa = 'BOTTOMRIGHT', x = 0, y = 0, col = 12, hide = 1 },
	['bVehicleFrame'] = 			{ a = 'BOTTOMLEFT', p = 'bMicroMenuFrame', pa = 'TOPLEFT', x = 0, y = 0, col = 12, hide = 0 },
	['bExtraBarFrame'] = 			{ a = 'BOTTOM', p = 'bVehicleFrame', pa = 'TOP', x = 0, y = 0, col = 12, hide = 0 },
}

if not _G["LibStub"] or _G["LibStub"].minor < 2 then
	local LibStub = _G["LibStub"] or {libs = {}, minors = {}, minor = 2}
	function LibStub:NewLibrary(major, minor)
		if self.minors[major] and self.minors[major] >= minor then return nil end
		self.minors[major], self.libs[major] = minor, self.libs[major] or {}
		return self.libs[major], self.minors[major]
	end
	function LibStub:GetLibrary(major, silent) return self.libs[major], self.minors[major] end
	function LibStub:IterateLibraries() return pairs(self.libs) end setmetatable(LibStub, { __call = LibStub.GetLibrary })
end

local LBFGroup
local LBF = LibStub("LibButtonFacade", true)

-- region ncHoverBind. authors: nightcracker, TMcMahon51
bBars.HoverBind = function()
	local bind, localmacros = CreateFrame('Frame', 'ncHoverBind', UIParent), 0
	if InCombatLockdown() then print('You can\'t bind keys in combat.') return end
	if not bind.loaded then
		local find = string.find
		local _G = getfenv(0)

		bind:SetFrameStrata('DIALOG')
		bind:EnableMouse(true)
		bind:EnableKeyboard(true)
		bind:EnableMouseWheel(true)
		bind.texture = bind:CreateTexture()
		bind.texture:SetAllPoints(bind)
		bind.texture:SetTexture(0, 0, 0, .25)
		bind:Hide()

		local elapsed = 0
		GameTooltip:HookScript('OnUpdate', function(self, e)
			elapsed = elapsed + e
			if elapsed < .2 then return else elapsed = 0 end
			if (not self.comparing and IsModifiedClick('COMPAREITEMS')) then
				GameTooltip_ShowCompareItem(self)
				self.comparing = true
			elseif ( self.comparing and not IsModifiedClick('COMPAREITEMS')) then
				for _, frame in pairs(self.shoppingTooltips) do
					frame:Hide()
				end
				self.comparing = false
			end
		end)
		hooksecurefunc(GameTooltip, 'Hide', function(self) for _, tt in pairs(self.shoppingTooltips) do tt:Hide() end end)

		bind:SetScript('OnEvent', function(self) self:Deactivate(false) end)
		bind:SetScript('OnLeave', function(self) self:HideFrame() end)
		bind:SetScript('OnKeyUp', function(self, key) self:Listener(key) end)
		bind:SetScript('OnMouseUp', function(self, key) self:Listener(key) end)
		bind:SetScript('OnMouseWheel', function(self, delta) if delta>0 then self:Listener('MOUSEWHEELUP') else self:Listener('MOUSEWHEELDOWN') end end)

		function bind:Update(b, spellmacro)
			if not self.enabled or InCombatLockdown() then return end
			self.button = b
			self.spellmacro = spellmacro
			
			self:ClearAllPoints()
			self:SetAllPoints(b)
			self:Show()
			
			ShoppingTooltip1:Hide()
			
			if spellmacro=='SPELL' then
				self.button.id = SpellBook_GetSpellID(self.button:GetID())
				self.button.name = GetSpellName(self.button.id, SpellBookFrame.bookType)
				
				GameTooltip:AddLine('Trigger')
				GameTooltip:Show()
				GameTooltip:SetScript('OnHide', function(self)
					self:SetOwner(bind, 'ANCHOR_NONE')
					self:SetPoint('BOTTOM', bind, 'TOP', 0, 1)
					self:AddLine(bind.button.name, 1, 1, 1)
					bind.button.bindings = {GetBindingKey(spellmacro..' '..bind.button.name)}
					if #bind.button.bindings == 0 then
						self:AddLine('No bindings set.', .6, .6, .6)
					else
						self:AddDoubleLine('Binding', 'Key', .6, .6, .6, .6, .6, .6)
						for i = 1, #bind.button.bindings do
							self:AddDoubleLine(i, bind.button.bindings[i])
						end
					end
					self:Show()
					self:SetScript('OnHide', nil)
				end)
			elseif spellmacro=='MACRO' then
				self.button.id = self.button:GetID()
				
				if localmacros==1 then self.button.id = self.button.id + 36 end
				
				self.button.name = GetMacroInfo(self.button.id)
				
				GameTooltip:SetOwner(bind, 'ANCHOR_NONE')
				GameTooltip:SetPoint('BOTTOM', bind, 'TOP', 0, 1)
				GameTooltip:AddLine(bind.button.name, 1, 1, 1)
				
				bind.button.bindings = {GetBindingKey(spellmacro..' '..bind.button.name)}
					if #bind.button.bindings == 0 then
						GameTooltip:AddLine('No bindings set.', .6, .6, .6)
					else
						GameTooltip:AddDoubleLine('Binding', 'Key', .6, .6, .6, .6, .6, .6)
						for i = 1, #bind.button.bindings do
							GameTooltip:AddDoubleLine('Binding'..i, bind.button.bindings[i], 1, 1, 1)
						end
					end
				GameTooltip:Show()
			elseif spellmacro=='STANCE' or spellmacro=='PET' then
				self.button.id = tonumber(b:GetID())
				self.button.name = b:GetName()
				
				if not self.button.name then return end
				
				if not self.button.id or self.button.id < 1 or self.button.id > (spellmacro=='STANCE' and 10 or 12) then
					self.button.bindstring = 'CLICK '..self.button.name..':LeftButton'
				else
					self.button.bindstring = (spellmacro=='STANCE' and 'SHAPESHIFTBUTTON' or 'BONUSACTIONBUTTON')..self.button.id
				end
				
				GameTooltip:AddLine('Trigger')
				GameTooltip:Show()
				GameTooltip:SetScript('OnHide', function(self)
					self:SetOwner(bind, 'ANCHOR_NONE')
					self:SetPoint('BOTTOM', bind, 'TOP', 0, 1)
					self:AddLine(bind.button.name, 1, 1, 1)
					bind.button.bindings = {GetBindingKey(bind.button.bindstring)}
					if #bind.button.bindings == 0 then
						self:AddLine('No bindings set.', .6, .6, .6)
					else
						self:AddDoubleLine('Binding', 'Key', .6, .6, .6, .6, .6, .6)
						for i = 1, #bind.button.bindings do
							self:AddDoubleLine(i, bind.button.bindings[i])
						end
					end
					self:Show()
					self:SetScript('OnHide', nil)
				end)
			else
				self.button.action = tonumber(b.action)
				self.button.name = b:GetName()
				
				if not self.button.name then return end
				
				if not self.button.action or self.button.action < 1 or self.button.action > 132 then
					self.button.bindstring = 'CLICK '..self.button.name..':LeftButton'
				else
					local modact = 1+(self.button.action-1)%12
					if self.button.action < 25 or self.button.action > 72 then
						self.button.bindstring = 'ACTIONBUTTON'..modact
					elseif self.button.action < 73 and self.button.action > 60 then
						self.button.bindstring = 'MULTIACTIONBAR1BUTTON'..modact
					elseif self.button.action < 61 and self.button.action > 48 then
						self.button.bindstring = 'MULTIACTIONBAR2BUTTON'..modact
					elseif self.button.action < 49 and self.button.action > 36 then
						self.button.bindstring = 'MULTIACTIONBAR4BUTTON'..modact
					elseif self.button.action < 37 and self.button.action > 24 then
						self.button.bindstring = 'MULTIACTIONBAR3BUTTON'..modact
					end
				end
				
				GameTooltip:AddLine('Trigger')
				GameTooltip:Show()
				GameTooltip:SetScript('OnHide', function(self)
					self:SetOwner(bind, 'ANCHOR_NONE')
					self:SetPoint('BOTTOM', bind, 'TOP', 0, 1)
					self:AddLine(bind.button.name, 1, 1, 1)
					bind.button.bindings = {GetBindingKey(bind.button.bindstring)}
					if #bind.button.bindings == 0 then
						self:AddLine('No bindings set.', .6, .6, .6)
					else
						self:AddDoubleLine('Binding', 'Key', .6, .6, .6, .6, .6, .6)
						for i = 1, #bind.button.bindings do
							self:AddDoubleLine(i, bind.button.bindings[i])
						end
					end
					self:Show()
					self:SetScript('OnHide', nil)
				end)
			end
		end

		function bind:Listener(key)
			if key == 'ESCAPE' or key == 'RightButton' then
				for i = 1, #self.button.bindings do
					SetBinding(self.button.bindings[i])
				end
				print('All keybindings cleared for |cff00ff00'..self.button.name..'|r.')
				self:Update(self.button, self.spellmacro)
				if self.spellmacro~='MACRO' then GameTooltip:Hide() end
				return
			end
			
			if key == 'LSHIFT'
			or key == 'RSHIFT'
			or key == 'LCTRL'
			or key == 'RCTRL'
			or key == 'LALT'
			or key == 'RALT'
			or key == 'UNKNOWN'
			or key == 'LeftButton'
			or key == 'MiddleButton'
			then return end
			
			if key == 'Button4' then key = 'BUTTON4' end
			if key == 'Button5' then key = 'BUTTON5' end
			
			local alt = IsAltKeyDown() and 'ALT-' or ''
			local ctrl = IsControlKeyDown() and 'CTRL-' or ''
			local shift = IsShiftKeyDown() and 'SHIFT-' or ''
			
			if not self.spellmacro or self.spellmacro=='PET' or self.spellmacro=='STANCE' then
				SetBinding(alt..ctrl..shift..key, self.button.bindstring)
			else
				SetBinding(alt..ctrl..shift..key, self.spellmacro..' '..self.button.name)
			end
			print(alt..ctrl..shift..key..' |cff00ff00bound to |r'..self.button.name..'.')
			self:Update(self.button, self.spellmacro)
			if self.spellmacro~='MACRO' then GameTooltip:Hide() end
		end
		function bind:HideFrame()
			self:ClearAllPoints()
			self:Hide()
			GameTooltip:Hide()
		end
		function bind:Activate()
			self.enabled = true
			self:RegisterEvent('PLAYER_REGEN_DISABLED')
		end
		function bind:Deactivate(save)
			if save then
				SaveBindings(2)
				print('All keybindings have been saved.')
			else
				LoadBindings(2)
				print('All newly set keybindings have been discarded.')
			end
			self.enabled = false
			self:HideFrame()
			self:UnregisterEvent('PLAYER_REGEN_DISABLED')
			StaticPopup_Hide('KEYBIND_MODE')
		end

		StaticPopupDialogs['KEYBIND_MODE'] = {
			text = 'Hover your mouse over any actionbutton to bind it. Press the escape key or right click to clear the current actionbutton\'s keybinding.',
			button1 = 'Save bindings',
			button2 = 'Discard bindings',
			OnAccept = function() bind:Deactivate(true) end,
			OnCancel = function() bind:Deactivate(false) end,
			timeout = 0,
			whileDead = 1,
			hideOnEscape = false
		}

		-- REGISTERING
		local stance = _G['ShapeshiftButton1'] and _G['ShapeshiftButton1']:GetScript('OnClick') or _G['Button1'] and _G['Button1']:GetScript('OnClick')
		local pet = PetActionButton1:GetScript('OnClick')
		local button = SecureActionButton_OnClick

		local function register(val)
			if val.IsProtected and val.GetObjectType and val.GetScript and val:GetObjectType()=='CheckButton' and val:IsProtected() then
				local script = val:GetScript('OnClick')
				if script==button then
					val:HookScript('OnEnter', function(self) bind:Update(self) end)
				elseif script==stance then
					val:HookScript('OnEnter', function(self) bind:Update(self, 'STANCE') end)
				elseif script==pet then
					val:HookScript('OnEnter', function(self) bind:Update(self, 'PET') end)
				end
			end
		end

		local val = EnumerateFrames()
		while val do
			register(val)
			val = EnumerateFrames(val)
		end

		for i=1,12 do
			local b = _G['SpellButton'..i]
			b:HookScript('OnEnter', function(self) bind:Update(self, 'SPELL') end)
		end
		
		local function registermacro()
			for i=1,36 do
				local b = _G['MacroButton'..i]
				b:HookScript('OnEnter', function(self) bind:Update(self, 'MACRO') end)
			end
			MacroFrameTab1:HookScript('OnMouseUp', function() localmacros = 0 end)
			MacroFrameTab2:HookScript('OnMouseUp', function() localmacros = 1 end)
		end
		
		if not IsAddOnLoaded('Blizzard_MacroUI') then
			hooksecurefunc('LoadAddOn', function(addon)
				if addon=='Blizzard_MacroUI' then
					registermacro()
				end
			end)
		else
			registermacro()
		end
		bind.loaded = 1
	end
	if not bind.enabled then
		bind:Activate()
		StaticPopup_Show('KEYBIND_MODE')
	end
end
-- end ncHoverBind region

-- region stick (FlyPaper library)
bBars.Stick = function(frame, otherFrame, tolerance, xOff, yOff)
	local function FrameIsDependentOnFrame(frame, otherFrame)
		if (frame and otherFrame) then
			if frame == otherFrame then return true end
			local points = frame:GetNumPoints()
			for i = 1, points do
				local parent = select(2, frame:GetPoint(i))
				if FrameIsDependentOnFrame(parent, otherFrame) then
					return true
				end
			end
		end
	end

	local function CanAttach(frame, otherFrame)
		if not(frame and otherFrame) then
			return
		elseif frame:GetNumPoints() == 0 or otherFrame:GetNumPoints() == 0 then
			return
		elseif frame:GetWidth() == 0 or frame:GetHeight() == 0 or otherFrame:GetWidth() == 0 or otherFrame:GetHeight() == 0 then
			return
		elseif FrameIsDependentOnFrame(otherFrame, frame) then
			return
		end
		return true
	end

	local function AttachToTop(frame, otherFrame, distLeft, distRight, distCenter, offset)
		frame:ClearAllPoints()
		if distLeft < distCenter and distLeft < distRight then
			frame:SetPoint('BOTTOMLEFT', otherFrame, 'TOPLEFT', 0, offset)
		elseif distRight < distCenter and distRight < distLeft then
			frame:SetPoint('BOTTOMRIGHT', otherFrame, 'TOPRIGHT', 0, offset)
		else
			frame:SetPoint('BOTTOM', otherFrame, 'TOP', 0, offset)
		end
	end

	local function AttachToBottom(frame, otherFrame, distLeft, distRight, distCenter, offset)
		frame:ClearAllPoints()
		if distLeft < distCenter and distLeft < distRight then
			frame:SetPoint('TOPLEFT', otherFrame, 'BOTTOMLEFT', 0, -offset)
		elseif distRight < distCenter and distRight < distLeft then
			frame:SetPoint('TOPRIGHT', otherFrame, 'BOTTOMRIGHT', 0, -offset)
		else
			frame:SetPoint('TOP', otherFrame, 'BOTTOM', 0, -offset)
		end
	end

	local function AttachToLeft(frame, otherFrame, distTop, distBottom, distCenter, offset)
		frame:ClearAllPoints()
		if distBottom < distTop and distBottom < distCenter then
			frame:SetPoint('BOTTOMRIGHT', otherFrame, 'BOTTOMLEFT', -offset, 0)
		elseif distTop < distBottom and distTop < distCenter then
			frame:SetPoint('TOPRIGHT', otherFrame, 'TOPLEFT', -offset, 0)
		else
			frame:SetPoint('RIGHT', otherFrame, 'LEFT', -offset, 0)
		end
	end

	local function AttachToRight(frame, otherFrame, distTop, distBottom, distCenter, offset)
		frame:ClearAllPoints()
		if distBottom < distTop and distBottom < distCenter then
			frame:SetPoint('BOTTOMLEFT', otherFrame, 'BOTTOMRIGHT', offset, 0)
		elseif distTop < distBottom and distTop < distCenter then
			frame:SetPoint('TOPLEFT', otherFrame, 'TOPRIGHT', offset, 0)
		else
			frame:SetPoint('LEFT', otherFrame, 'RIGHT', offset, 0)
		end
	end

	function StickFrames(frame, otherFrame, tolerance, xOff, yOff)
		local xOff, yOff = xOff or 0, yOff or 0
		local left = frame:GetLeft()
		local right = frame:GetRight()
		local top = frame:GetTop()
		local bottom = frame:GetBottom()
		local centerX, centerY = frame:GetCenter()

		if not CanAttach(frame, otherFrame) then return end
		
		if left and right and top and bottom and centerX then
			local oScale = otherFrame:GetScale()
			left = left / oScale
			right = right / oScale
			top = top / oScale
			bottom = bottom /oScale
			centerX = centerX / oScale
			centerY = centerY / oScale
		else return end

		local oLeft = otherFrame:GetLeft()
		local oRight = otherFrame:GetRight()
		local oTop = otherFrame:GetTop()
		local oBottom = otherFrame:GetBottom()
		local oCenterX, oCenterY = otherFrame:GetCenter()

		if oLeft and oRight and oTop and oBottom and oCenterX then
			local scale = frame:GetScale()
			oCenterX = oCenterX / scale
			oCenterY = oCenterY / scale
			oLeft = oLeft / scale
			oRight = oRight / scale
			oTop = oTop / scale
			oBottom = oBottom / scale
		else return end

		if(oLeft - tolerance <= left and oRight + tolerance >= right) or (left - tolerance <= oLeft and right + tolerance >= oRight)then
			local distCenter = math.abs(oCenterX - centerX)
			local distLeft = math.abs(oLeft - left)
			local distRight = math.abs(right - oRight)

			if math.abs(oTop - bottom) <= tolerance then 
				return AttachToTop(frame, otherFrame, distLeft, distRight, distCenter, yOff) 
			elseif math.abs(oBottom - top) <= tolerance then 
				return AttachToBottom(frame, otherFrame, distLeft, distRight, distCenter, yOff)
			end
		end

		if(oTop + tolerance >= top and oBottom - tolerance <= bottom) or (top + tolerance >= oTop and bottom - tolerance <= oBottom) then
			local distCenter = math.abs(oCenterY - centerY)
			local distTop = math.abs(oTop - top)
			local distBottom = math.abs(oBottom - bottom)
			
			if math.abs(oLeft - right) <= tolerance then return AttachToLeft(frame, otherFrame, distTop, distBottom, distCenter, xOff) end
			if math.abs(oRight - left) <= tolerance then return AttachToRight(frame, otherFrame, distTop, distBottom, distCenter, xOff) end
		end
	end
	StickFrames(frame, otherFrame, tolerance, xOff, yOff)
end
-- end stick region

-- hide blizzard frames region
bBars.HideBlizzard = function()
	local hider = _G['BlizzardHider'] or CreateFrame('Frame', 'BlizzardHider', UIParent)
	hider:Hide()
	
	for i,v in pairs({'MainMenuBar', 'MultiBarBottomLeft', 'MultiBarBottomRight', 'MultiBarLeft', 'MultiBarRight', 'ShapeshiftBarFrame', 'BonusActionBarFrame', 'PossessBarFrame', 'MainMenuExpBar', 'MainMenuBarArtFrame'})do
		if _G[v] then
			_G[v]:UnregisterAllEvents()
			_G[v]:SetParent(hider)
			_G[v]:Hide()
		end
	end

	for i,v in pairs({'MultiBarRight', 'MultiBarLeft', 'MultiBarBottomLeft', 'MultiBarBottomRight', 'MainMenuBar', 'ShapeshiftBarFrame', 'PossessBarFrame', 'MultiCastActionBarFrame', 'PETACTIONBAR_YPOS', 'MULTICASTACTIONBAR_YPOS'}) do
		if UIPARENT_MANAGED_FRAME_POSITIONS[v] then
			UIPARENT_MANAGED_FRAME_POSITIONS[v] = nil
		end
	end

	MainMenuBarArtFrame:RegisterEvent('BAG_UPDATE'); MainMenuBarArtFrame:RegisterEvent('CURRENCY_DISPLAY_UPDATE')
	
	if not _G['VehicleSeatIndicator']:IsUserPlaced() then _G['VehicleSeatIndicator']:SetPoint('TOPRIGHT', MinimapCluster, 'BOTTOMRIGHT', 0, -13) end
	for i = 1, 6 do 
		if _G['VehicleMenuBarActionButton'..i] then _G['VehicleMenuBarActionButton'..i]:UnregisterAllEvents() end 
	end
	for i = 1, 12 do 
		if _G['BonusActionButton'..i] then _G['BonusActionButton'..i]:UnregisterAllEvents() end
		if _G['MultiCastActionButton'..i] then _G['MultiCastActionButton'..i]:UnregisterEvent('UPDATE_BINDINGS') end
	end
	
	if PlayerTalentFrame then
		PlayerTalentFrame:UnregisterEvent('ACTIVE_TALENT_GROUP_CHANGED')
	else
		hooksecurefunc('TalentFrame_LoadUI', function() PlayerTalentFrame:UnregisterEvent('ACTIVE_TALENT_GROUP_CHANGED') end)
	end

	MultiActionBar_UpdateGrid = function() end
end
-- end region

bBars.UpdateBind = function(self, buttonType)
	local macro = _G[self:GetName()..'Name'] or self:CreateFontString(self:GetName()..'Name', 'ARTWORK')
	local hotkey = _G[self:GetName()..'HotKey'] or self:CreateFontString(self:GetName()..'HotKey', 'ARTWORK')

	local bind = self:GetAttribute('binding')
	local key = bind and GetBindingKey(bind) or GetBindingKey('CLICK '..self:GetName()..':LeftButton')
		
	if key then
		key = key:lower():gsub('^button(%d+)$', 'B%1')
		key = key:lower():gsub('shift%-', 'S')
		key = key:lower():gsub('alt%-', 'A')
		key = key:lower():gsub('ctrl%-', 'C')
		key = key:lower():gsub('numpad%-', 'N')
		
		hotkey:SetText(GetBindingText(key, 'KEY_', 1):lower())
		if BarsDB.keybindings == 1 then hotkey:Show() else hotkey:Hide() end
	end
	
	if macro then if BarsDB.macroses == 1 then macro:Show() else macro:Hide() end end
end

ActionButton_UpdateHotkeys = bBars.UpdateBind

bBars.setStyle = function(self)
	if self.styled then return end
	local button = 	self
	local bname = 	button:GetName()
	local icon = 	_G[bname..'Icon']
	local border = 	_G[bname..'Border']
	local fbg = 	_G[bname..'FloatingBG']
	local nt = 		_G[bname..'NormalTexture'] and _G[bname..'NormalTexture'] or button:GetNormalTexture() and button:GetNormalTexture() or nil
	local flash = 	_G[bname..'Flash']
	local count = 	_G[bname..'Count']

	local macro = _G[self:GetName()..'Name'] or self:CreateFontString(self:GetName()..'Name', 'ARTWORK')
	local hotkey = _G[self:GetName()..'HotKey'] or self:CreateFontString(self:GetName()..'HotKey', 'ARTWORK')

	if count then
		count:SetFont('Interface\\AddOns\\'..addonName..'\\pixel.ttf', 8, 'THINOUTLINEMONOCHROME')
		count:SetShadowOffset(0, 0)
		count.SetTextHeight = function() end
		count.SetTextWidth = function() end
		count.SetFont = function() end
	end
	hotkey:SetFont('Interface\\AddOns\\'..addonName..'\\pixel.ttf', 8, 'THINOUTLINEMONOCHROME')
	hotkey:SetShadowOffset(0, 0)
	hotkey.SetTextHeight = function() end
	hotkey.SetTextWidth = function() end
	hotkey.SetFont = function() end
	
	hotkey:ClearAllPoints()
	hotkey:SetPoint('TOPRIGHT', -3, -3)
	hotkey:SetJustifyH('RIGHT')
	hotkey.ClearAllPoints = function() end
	hotkey.SetPoint = function() end
	

	macro:SetFont('Interface\\AddOns\\'..addonName..'\\pixel.ttf', 8, 'OUTLINEMONOCHROME')
	macro:SetShadowOffset(0, 0)
	macro.SetFont = function() end
	
	if fbg then fbg:Hide() fbg.Show = function() end end
	local pushed, checked, highlight = button.GetPushedTexture and button:GetPushedTexture() or nil, button.GetCheckedTexture and button:GetCheckedTexture() or nil, button.GetHighlightTexture and button:GetHighlightTexture() or nil
	
	if LBF and LBFGroup and nt and not bname:lower():find('micro') then return end
	
	if icon then 
		icon:SetTexCoord(0.1, 0.9, 0.1, 0.9) 
		icon:ClearAllPoints()
		icon:SetAllPoints()
	end

	if border then 
		border:SetTexture(BarsDB.tex) 
		border:SetAllPoints()
	else
		if bname:find('MicroButton') then
			border = _G[bname..'Border'] or button:CreateTexture(bname..'Border', 'BACKGROUND')
			border:SetTexture(BarsDB.tex)
			border:SetAllPoints()
		end
	end
	
	if flash then
		flash:SetTexture(BarsDB.tex)
		flash:ClearAllPoints()
		flash:SetAllPoints(button)
		flash.SetPoint = function() end
		flash.SetTexture = function() end
	end
	
	if pushed then
		if not bname:find('MicroButton') then
			pushed:SetTexCoord(.1,.9,.1,.9)
		else
			pushed:SetTexCoord(.15, .84, .5, .9)
		end
		pushed:ClearAllPoints()
		pushed:SetAllPoints(button)
		pushed.SetPoint = function() end
	end
	
	if checked then
		checked:SetTexCoord(.1,.9,.1,.9)
		checked:ClearAllPoints()
		checked:SetAllPoints(button)
		checked.SetPoint = function() end
	end

	if highlight then
		highlight:SetTexture(BarsDB.tex)
		highlight:SetTexCoord(.1,.9,.1,.9)
		highlight:ClearAllPoints()
		highlight:SetAllPoints(button)
		highlight.SetPoint = function() end
	end
	
	if nt then
		if not bname:lower():find('microbutton') and not bname:lower():find('vehicle') then
			nt:SetTexture(BarsDB.tex)
		else
			nt:SetTexCoord(.15, .84, .48, .9)
		end
		nt:ClearAllPoints()
		nt:SetAllPoints()
		
		nt:SetVertexColor(.2, .2, .2, 1)
		
		if not button.hooked then
			hooksecurefunc(nt, 'SetVertexColor', function(snt, r, g, b, a)
				if snt then
					local self = snt:GetParent()
					if self then
						local action = self.action
						if r==1 and g==1 and b==1 and action and (IsEquippedAction(action)) then
							snt:SetVertexColor(0,1,0,1)
						elseif r==0.5 and g==0.5 and b==1 then
							snt:SetVertexColor(0,0,1,1)
						elseif r==1 and g==1 and b==1 then
							snt:SetVertexColor(.2,.2,.2,1)
						end
					end
				end
			end)
			button.hooked = true
		end
	end
	
	self.styled = true
end

hooksecurefunc('ActionButton_Update', bBars.setStyle)
hooksecurefunc('PetActionBar_Update', function()
	for i=1, NUM_PET_ACTION_SLOTS do
		local name = 'PetActionButton'..i
		local button  = _G[name]
		button.styled = false
		bBars.setStyle(button)
	end  
end)

bBars.UpdateAll = function()
	for i, v in pairs(bBars.frames) do
		local opt = BarsDB[v:GetName()]
		if v:GetName() ~= 'MultiCastActionBarFrame' then
			for j,k in pairs(v.buttons) do

				local bsize = (66/36) * opt.size
				if _G[k:GetName()..'Shine'] then _G[k:GetName()..'Shine']:SetSize(opt.size, opt.size) end
				if _G[k:GetName()..'AutoCastable'] then _G[k:GetName()..'AutoCastable']:SetSize(bsize, bsize) end
				
				k:SetSize(opt.size, opt.size)
				bBars.UpdateBind(k)
				k.styled = nil
				bBars.setStyle(k)
				
				if #v.buttons > 0 then
					local cols = min(BarsDB[v:GetName()].col, #v.buttons)
					local rows = ceil(#v.buttons / cols)
					local spacing, padding = opt.gap, opt.gap
					local b = v.buttons[1]
					local w, h = b:GetWidth() + spacing, b:GetHeight() + spacing

					for i,b in pairs(v.buttons) do
						b:ClearAllPoints()
						b:SetPoint('TOPLEFT', w*((i-1) % cols) + padding, -(h*(ceil(i / cols) - 1) + padding))
					end

					v:SetSize(max(w*cols - spacing + padding*2, 8), max(h*ceil(#v.buttons/cols) - spacing + padding*2, 8))
				else
					v:SetSize(30, 30)
				end
				
				local nt = _G[k:GetName()..'NormalTexture'] and _G[k:GetName()..'NormalTexture'] or k:GetNormalTexture() and k:GetNormalTexture() or nil
				if LBF and LBFGroup and nt and not k:GetName():lower():find('micro') then
					LBFGroup:RemoveButton(k)
					LBFGroup:AddButton(k)
					k.styled = true
				end
				
			end
		end
				
		local point, relativeTo, relativePoint, x, y = unpack(opt.setPoint)
		v:ClearAllPoints()
		if relativeTo then
			v:SetPoint(point, relativeTo, relativePoint, x, y)
		else
			v:SetPoint(point, 'UIParent', relativePoint, x, y)
		end
	end
	UIPARENT_MANAGED_FRAME_POSITIONS['CONTAINER_OFFSET_X'] = {baseX = 0, rightLeft = 2*32+3, rightRight = 32+3, isVar = 'xAxis'}
	MultiActionBar_Update()
    UIParent_ManageFramePositions()
end

bBars.AddConfigButtons = function(f)
	local fname = f:GetName()
	
	if BarsDB[fname] == nil then BarsDB[fname] = {} end
	if bBars.default_positions[fname] then
		if BarsDB[fname].col == nil then BarsDB[fname].col = bBars.default_positions[fname].col ~= nil and bBars.default_positions[fname].col or 12 end
		if BarsDB[fname].size == nil then BarsDB[fname].size = bBars.default_positions[fname].size ~= nil and bBars.default_positions[fname].size or 30 end
		if BarsDB[fname].gap == nil then BarsDB[fname].gap = bBars.default_positions[fname].gap ~= nil and bBars.default_positions[fname].gap or 1 end
		if BarsDB[fname].hide == nil then BarsDB[fname].hide = bBars.default_positions[fname].hide ~= nil and bBars.default_positions[fname].hide == 1 or false end
	else
		if BarsDB[fname].col == nil then BarsDB[fname].col = 12 end
		if BarsDB[fname].size == nil then BarsDB[fname].size = 30 end
		if BarsDB[fname].gap == nil then BarsDB[fname].gap = 1 end
		if BarsDB[fname].hide == nil then BarsDB[fname].hide = false end
	end
	if BarsDB[fname].setPoint == nil then
		if fname and bBars.default_positions[fname] then
			local opt = bBars.default_positions[fname]
			f:SetPoint(opt.a, opt.p, opt.pa, opt.x, opt.y)
		else
			f:SetPoint('CENTER', 0, 0)
		end
		
		local point, relativeTo, relativePoint, x, y = f:GetPoint()
		BarsDB[fname].setPoint = { point, relativeTo:GetName(), relativePoint, x, y }
	end

	f:SetScript('OnMouseWheel', function(self, value)
		if not bBars.config then return end
		if InCombatLockdown() or UnitAffectingCombat('player') then return end
		if IsShiftKeyDown() then
			if value > 0 then
				BarsDB[fname].size = BarsDB[fname].size + 1
			else
				BarsDB[fname].size = BarsDB[fname].size - 1
			end
		elseif IsAltKeyDown() then
			if value > 0 then
				BarsDB[fname].gap = BarsDB[fname].gap + 1
			else
				BarsDB[fname].gap = BarsDB[fname].gap - 1
			end
		else
			if value > 0 then
				if BarsDB[fname].col > 1 then BarsDB[fname].col = BarsDB[fname].col - 1 end
			else
				if BarsDB[fname].col < 12 then BarsDB[fname].col = BarsDB[fname].col + 1 end
			end
		end
		
		bBars.UpdateAll()
	end)
	
	if f.buttons ~= nil then
		for i,v in pairs(f.buttons) do
			local nt = _G[v:GetName()..'NormalTexture'] and _G[v:GetName()..'NormalTexture'] or v:GetNormalTexture() and v:GetNormalTexture() or nil
			if(LBF and LBFGroup and nt and not v:GetName():lower():find('micro')) then 
				LBFGroup:AddButton(v)
				v.styled = true
			end
		end
	end
end

bBars.MakeActionButtonsFrame = function(name, id)
	local buttonId = 1
	local f = _G[name] or CreateFrame('frame', name, UIParent, 'SecureHandlerStateTemplate')
	if id > 2 then f:SetAttribute('actionpage', id) end
	
	f.buttons = {}
	
	for i=id*12-11, id*12 do
		local bname = name..'Button'..i
		local b, bind
		local modact = 1+(i-1)%12
		if id == 1 then
			b = _G['ActionButton'..i]
			if b then 
				f:SetFrameRef(b:GetName(), b)
				b:SetAttribute('binding', 'ACTIONBUTTON'..modact)
			end
		else
			if i <= 36 then
				b = _G['MultiBarRightButton'..(i-24)]
				if b then b:SetAttribute('binding', 'MULTIACTIONBAR3BUTTON'..modact)  end
			elseif i <= 48 then
				b = _G['MultiBarLeftButton'..(i-36)]
				if b then b:SetAttribute('binding', 'MULTIACTIONBAR4BUTTON'..modact) end
			elseif i <= 60 then
				b = _G['MultiBarBottomRightButton'..(i-48)]
				if b then b:SetAttribute('binding', 'MULTIACTIONBAR2BUTTON'..modact) end
			elseif i <= 72 then
				b = _G['MultiBarBottomLeftButton'..(i-60)]
				if b then b:SetAttribute('binding', 'MULTIACTIONBAR1BUTTON'..modact) end
			end
			
			if not b then 
				b = _G[bname] or CreateFrame('CheckButton', bname, f, 'ActionBarButtonTemplate') 
				b:SetAttribute('binding', 'ACTIONBUTTON'..modact)
			end
		end

		if b then
			bBars.setStyle(b)
			b:SetParent(f)
			b:SetAttribute('unit2', 'player')
			bBars.UpdateBind(b)
			b.icon = _G[b:GetName()..'Icon']
			b:SetID(buttonId)
			buttonId = buttonId + 1
			
			hooksecurefunc(_G[b:GetName()..'HotKey'], 'SetVertexColor', function(self, ...) 
				local isUsable, notEnoughMana = IsUsableAction(b.action)
				if (ActionHasRange(b.action) and IsActionInRange(b.action) == 0) then
					b.icon:SetVertexColor(1, 0, 0)
					return
				elseif (notEnoughMana) then
					b.icon:SetVertexColor(.1, .3, 1)
					return
				elseif (isUsable) then
					b.icon:SetVertexColor(1, 1, 1, 1)
					return
				else
					b.icon:SetVertexColor(0.4, 0.4, 0.4, 1)
					return
				end			
			end)
			
			table.insert(f.buttons, b)
		end
	end


	local GetBar = function()
		local Page = {
			['DRUID'] = '[bonusbar:1,nostealth] 7; [bonusbar:1,stealth] 8; [bonusbar:2] 8; [bonusbar:3] 9; [bonusbar:4] 10;',		
			['WARRIOR'] = '[bonusbar:1] 7; [bonusbar:2] 8; [bonusbar:3] 9;',
			['PRIEST'] = '[bonusbar:1] 7;',
			['ROGUE'] = '[bonusbar:1] 7; [bonusbar:2] 8;',
			['WARLOCK'] = '[form:2] 10;',
			['DEFAULT'] = '[bar:2] 2; [bar:3] 3; [bar:4] 4; [bar:5] 5; [bar:6] 6; [bonusbar:5] 11;',
		}
		local condition = Page['DEFAULT']
		local page = Page[select(2, UnitClass('player'))]
		if page then condition = condition..' '..page end
		condition = condition..' 1'
		return condition
	end
	
	if id == 1 then
		f:Execute([[ buttons = table.new() for i = 1, 12 do table.insert(buttons, self:GetFrameRef('ActionButton'..i)) end ]])
		f:SetAttribute('_onstate-page', [[  for i, button in ipairs(buttons) do button:SetAttribute('actionpage', tonumber(newstate)) end ]])
		RegisterStateDriver(f, 'page', GetBar())
	end
	
	bBars.AddConfigButtons(f)
	if BarsDB[name].hide then f:Hide() else f:Show() end
	table.insert(bBars.frames, f)
end

bBars.MakeTotemFrame = function()
	local _,class = UnitClass('player')
	if (class == 'SHAMAN') then
		local fname = MultiCastActionBarFrame:GetName()

		if not BarsDB[fname] then BarsDB[fname] = {} end
		if not BarsDB[fname].col then BarsDB[fname].col = 6 end
		if not BarsDB[fname].size then BarsDB[fname].size = 30 end
		
		UIPARENT_MANAGED_FRAME_POSITIONS['MultiCastActionBarFrame'] = nil
		MultiCastActionBarFrame:SetScript('OnUpdate', nil)
		MultiCastActionBarFrame_OnUpdate = function() end
		MultiCastActionBarFrame:SetScript('OnShow', nil)
		MultiCastActionBarFrame:SetScript('OnHide', nil)
		MultiCastActionBarFrame:SetParent(UIParent)
		MultiCastActionBarFrame:ClearAllPoints()
		MultiCastActionBarFrame:SetPoint('CENTER')
		MultiCastFlyoutFrame:SetFrameStrata('HIGH')
		MultiCastActionBarFrame.SetParent = function() end
		MultiCastRecallSpellButton.SetPoint = function() end
		if not MultiCastActionBarFrame.buttons then
			MultiCastActionBarFrame.buttons = {}
			for i = 1, NUM_MULTI_CAST_BUTTONS_PER_PAGE do
				table.insert(MultiCastActionBarFrame.buttons, _G['MultiCastSlotButton'..i])
			end
			table.insert(MultiCastActionBarFrame.buttons, _G['MultiCastSummonSpellButton'])
			table.insert(MultiCastActionBarFrame.buttons, _G['MultiCastRecallSpellButton'])
		end
		
		bBars.AddConfigButtons(MultiCastActionBarFrame)
		if BarsDB[fname].hide then MultiCastActionBarFrame:Hide() else MultiCastActionBarFrame:Show() end
		table.insert(bBars.frames, MultiCastActionBarFrame)
	end
end

bBars.MakePetFrame = function()
	local fname = 'bPetFrame'
	local f = _G[fname] or CreateFrame('frame', fname, UIParent, 'SecureHandlerStateTemplate')
	
	f.buttons = {}
	
	for i=1, 12 do
		local b = _G['PetActionButton'..i]
		
		if b then
			b:SetAttribute('binding', 'BONUSACTIONBUTTON'..i)
			b:SetParent(f)
			b:SetID(i)
			bBars.setStyle(b)
			bBars.UpdateBind(b)
			table.insert(f.buttons, b)
		end
	end
	
	bBars.AddConfigButtons(f)
	if BarsDB[fname].hide then f:Hide() else f:Show() end
	table.insert(bBars.frames, f)
end

bBars.MakeShapeShiftFrame = function()
	local fname = 'bShapeshiftFrame'
	local f = _G[fname] or CreateFrame('frame', fname, UIParent, 'SecureHandlerStateTemplate')
	
	f.buttons = {}
	
	for i=1,GetNumShapeshiftForms() do
		local bname = 'Button'..i
		local b = _G[bname] or CreateFrame('CheckButton', bname, f, 'SecureActionButtonTemplate')
		b:SetParent(f)
		b:SetID(i)
		b:RegisterForClicks('AnyUp')
		
		b.icon = _G[bname..'Icon'] or b:CreateTexture(bname..'Icon', 'BACKGROUND')
		b.icon:SetAllPoints(b)

		b:SetNormalTexture('Interface\\Buttons\\UI-Quickslot2')
		b:SetPushedTexture('Interface\\Buttons\\UI-Quickslot-Depress')
		b:SetHighlightTexture('Interface\\Buttons\\ButtonHilight-Square')
		b:SetCheckedTexture('Interface\\Buttons\\CheckButtonHilight')
		b:SetScript('OnEnter', function(self) GameTooltip:SetOwner(self, 'ANCHOR_RIGHT') GameTooltip:SetShapeshift(self:GetID()) end)
		b:SetScript('OnLeave', function(self) GameTooltip:Hide() end)
		
		b.hotkey = _G[bname..'HotKey'] or b:CreateFontString(bname..'HotKey', 'ARTWORK')
		b.hotkey:SetFontObject('NumberFontNormalSmallGray')
		b.hotkey:SetPoint('TOPRIGHT', 2, -2)
		b.hotkey:SetJustifyH('RIGHT')
		b.hotkey:SetHeight(10)

		b.cooldown = _G[bname..'Cooldown'] or CreateFrame('Cooldown', bname..'Cooldown', b, 'CooldownFrameTemplate')
		b.cooldown:SetAllPoints(b)
		
		b:SetAttribute('type', 'spell')
		b:SetAttribute('spell', select(2, GetShapeshiftFormInfo(b:GetID())))
		local texture, name, isActive, isCastable = GetShapeshiftFormInfo(b:GetID())
		b.icon:SetTexture(texture)
		
		b:RegisterEvent('UPDATE_BINDINGS')
		b:RegisterEvent('UPDATE_SHAPESHIFT_FORMS')
		b:RegisterEvent('PLAYER_ENTERING_WORLD')
		b:RegisterEvent('SPELL_UPDATE_COOLDOWN')
		b:RegisterEvent('SPELL_UPDATE_USABLE')
		b:RegisterEvent('UNIT_AURA')
		
		b:SetScript('OnEvent', function(self, event)
			if (self:GetID() > GetNumShapeshiftForms()) then
				self:Hide()
				return
			end
			if event == 'UPDATE_SHAPESHIFT_FORMS' and (self:GetID() > GetNumShapeshiftForms()) then
				self:Hide()
			elseif event == 'UPDATE_BINDINGS' then
				bBars.UpdateBind(self)
			elseif event == 'UNIT_AURA' then
				if arg1 == 'player' then
					self.Update(self)
				end
			else
				self.Update(self)
			end
		end)
		
		b.Update = function(self)
			local texture, name, isActive, isCastable = GetShapeshiftFormInfo(self:GetID())
			self:SetChecked(isActive)
			self.icon:SetTexture(texture)
			if isCastable then self.icon:SetVertexColor(1, 1, 1) else self.icon:SetVertexColor(0.4, 0.4, 0.4) end
			if texture then
				local start, duration, enable = GetShapeshiftFormCooldown(self:GetID())
				CooldownFrame_SetTimer(self.cooldown, start, duration, enable)
			else
				self.cooldown:Hide()
			end
		end
		
		bBars.setStyle(b)
		
		table.insert(f.buttons, b)
	end
	
	bBars.AddConfigButtons(f)
	if BarsDB[fname].hide then f:Hide() else f:Show() end
	table.insert(bBars.frames, f)
end

bBars.MakeBagsFrame = function()
	local fname = 'bBagsFrame'
	local f = _G[fname] or CreateFrame('frame', fname, UIParent)
	
	f.buttons = {_G['CharacterBag3Slot'], _G['CharacterBag2Slot'], _G['CharacterBag1Slot'], _G['CharacterBag0Slot'], _G['MainMenuBarBackpackButton']}
	for i,v in pairs(f.buttons) do
		v:SetParent(f)
	end
	
	bBars.AddConfigButtons(f)
	if BarsDB[fname].hide then f:Hide() else f:Show() end
	table.insert(bBars.frames, f)
end

bBars.MakeMicroMenuFrame = function()
	MainMenuMicroButton_SetPushed = function() end
	MainMenuMicroButton_SetNormal = function() end
	
	local fname = 'bMicroMenuFrame'
	local f = _G[fname] or CreateFrame('frame', fname, UIParent)
	local getButtons = function(...)
		f.buttons = {}
		for i, v in pairs(MICRO_BUTTONS) do
			local b = _G[v]
			b:SetHitRectInsets(0, 0, 0, 0)
			local name = b:GetName()
			if _G[name..'Texture'] then
				_G[name..'Texture']:SetTexCoord(0, .65, 0, .65)
				_G[name..'Texture']:ClearAllPoints()
				_G[name..'Texture']:SetAllPoints()
			end
			if _G[name..'Tabard'] then
				_G[name..'Tabard']:ClearAllPoints()
				_G[name..'Tabard']:SetAllPoints()
				
				if _G[name..'TabardBackground'] then
					_G[name..'TabardBackground']:SetTexCoord(.1, .9, .45, .9)
					_G[name..'TabardBackground']:ClearAllPoints()
					_G[name..'TabardBackground']:SetAllPoints()
				end
				
				if _G[name..'TabardEmblem'] then
					_G[name..'TabardEmblem']:ClearAllPoints()
					_G[name..'TabardEmblem']:SetPoint('TOPLEFT', 4, -4)
					_G[name..'TabardEmblem']:SetPoint('BOTTOMRIGHT', -4, 4)
				end
			end
			
			if _G['MainMenuBarPerformanceBar'] then
				_G['MainMenuBarPerformanceBar']:SetTexture(BarsDB.tex)
				_G['MainMenuBarPerformanceBar']:ClearAllPoints()
				_G['MainMenuBarPerformanceBar']:SetAllPoints()
				_G['MainMenuBarPerformanceBar']:SetAlpha(.1)
			end
			b:SetParent(f)
			table.insert(f.buttons, b)
		end
		
		do
			MicroButtonPortrait:ClearAllPoints()
			MicroButtonPortrait:SetPoint('TOPLEFT', CharacterMicroButton, 'TOPLEFT', 2, -2)
			MicroButtonPortrait:SetPoint('BOTTOMRIGHT', CharacterMicroButton, 'BOTTOMRIGHT', -2, 2)
		end
	
		return f.buttons
	end
	
	f.buttons = f.buttons or getButtons(_G['MainMenuBarArtFrame']:GetChildren())
	
	bBars.AddConfigButtons(f)
	if BarsDB[fname].hide then f:Hide() else f:Show() end
	table.insert(bBars.frames, f)
end

bBars.MakeVehicleFrame = function()
	local fname = 'bVehicleFrame'
	local f = _G[fname] or CreateFrame('frame', fname, UIParent, 'SecureHandlerStateTemplate')
	
	f.buttons = {}

	local b = CreateFrame('Button', 'VehicleLeaveButton1', f)
	b:SetNormalTexture('Interface\\Vehicles\\UI-Vehicles-Button-Exit-Up')
	b:SetPushedTexture('Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down')
	b:SetHighlightTexture('Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down')
	
	b:RegisterEvent('UNIT_ENTERED_VEHICLE')
	b:RegisterEvent('UNIT_EXITED_VEHICLE')
	b:SetSize(32,32)
	
	b:SetScript('OnClick', function(self) VehicleExit() end)
	b:SetScript('OnEvent', function(self) if CanExitVehicle() then self:Show() else self:Hide() end end)
	b:Hide()
	bBars.AddConfigButtons(f)
	if BarsDB[fname].hide then f:Hide() else f:Show() end
	table.insert(f.buttons, b)
	table.insert(bBars.frames, f)
end

bBars.MakeExtraBarFrame = function()
	local fname = 'bExtraBarFrame'
	local f = _G[fname] or CreateFrame('frame', fname, UIParent, 'SecureHandlerShowHideTemplate')
	
	f.buttons = {}

	local i = 1
	while _G['ExtraActionButton'..i] ~= nil do
		local b = _G['ExtraActionButton'..i]
		b.style:SetTexture(nil)
		b:SetParent(f)
		
		b:RegisterEvent('UNIT_INVENTORY_CHANGED')
		b:RegisterEvent('PLAYER_ENTERING_WORLD')
		b:RegisterEvent('UPDATE_EXTRA_ACTIONBAR')
		b:SetScript('OnShow', function(self) if not HasExtraActionBar() then self:Hide() end end)
		b:SetScript('OnEvent', function(self, event) if HasExtraActionBar() then self:Show() return else self:Hide() end end)
		
		table.insert(f.buttons, b)
		i = i + 1
	end
	bBars.AddConfigButtons(f)
	if BarsDB[fname].hide then f:Hide() else f:Show() end
	table.insert(bBars.frames, f)
end

-- minimap button
bBars.CreateMinimapButton = function()
	if _G['bBarsMinimapButton'] then return end

	local bBarsDropDown = CreateFrame('Frame', 'bBarsDropDown', nil, 'UIDropDownMenuTemplate')
	UIDropDownMenu_Initialize(bBarsDropDown, function()
		local button = {
			{ text = 'Show keybinds', func = function(self) if BarsDB.keybindings == 1 then BarsDB.keybindings = 0 else BarsDB.keybindings = 1 end bBars.UpdateAll() end, checked = BarsDB.keybindings == 1, notCheckable = BarsDB.keybindings == 0 },
			{ text = 'Show macro', func = function(self) if BarsDB.macroses == 1 then BarsDB.macroses = 0 else BarsDB.macroses = 1 end bBars.UpdateAll() end, checked = BarsDB.macroses == 1, notCheckable = BarsDB.macroses == 0 },
		}
		 
		for i=1, #button do	UIDropDownMenu_AddButton(button[i])	end
	end, 'MENU')
	
	local function MoveMinimapButton()
		local xpos, ypos
		local minimapShape = GetMinimapShape and GetMinimapShape() or 'ROUND'
		if minimapShape == 'SQUARE' then
			xpos = 110 * cos(BarsDB.minimapPos)
			ypos = 110 * sin(BarsDB.minimapPos)
			xpos = math.max(-82, math.min(xpos, 84))
			ypos = math.max(-86, math.min(ypos, 82))
		else
			xpos = 80 * cos(BarsDB.minimapPos)
			ypos = 80 * sin(BarsDB.minimapPos)
		end
		_G['bBarsMinimapButton']:SetPoint('TOPLEFT', Minimap, 'TOPLEFT', 54-xpos, ypos-54)
	end

	local function DragMinimapButton()
		local xpos, ypos = GetCursorPosition()
		local xmin, ymin = Minimap:GetLeft() or 400, Minimap:GetBottom() or 400
		local scale = Minimap:GetEffectiveScale()
		xpos = xmin-xpos/scale+70
		ypos = ypos/scale-ymin-70
		BarsDB.minimapPos = math.deg(math.atan2(ypos, xpos))
		MoveMinimapButton()
	end

	local MinimapButton = CreateFrame('Button', 'bBarsMinimapButton', Minimap)
	MinimapButton:EnableMouse(true)
	MinimapButton:SetMovable(true)
	MinimapButton:SetToplevel(true)
	MinimapButton:SetWidth(32)
	MinimapButton:SetHeight(32)
	MinimapButton:SetPoint('TOPLEFT')
	MinimapButton:SetFrameStrata('LOW')
	MinimapButton:RegisterForClicks('AnyUp')
	MinimapButton:RegisterForDrag('LeftButton')

	local texture = MinimapButton:CreateTexture(nil, 'ARTWORK')
	texture:SetWidth(54)
	texture:SetHeight(54)
	texture:SetPoint('TOPLEFT')
	texture:SetTexture('Interface\\Minimap\\MiniMap-TrackingBorder')

	local texture = MinimapButton:CreateTexture(nil, 'BACKGROUND')
	texture:SetWidth(24)
	texture:SetHeight(24)
	texture:SetPoint('TOPLEFT', 2, -4)
	texture:SetTexture('Interface\\Minimap\\UI-Minimap-Background')

	local NormalTexture = MinimapButton:CreateTexture(nil, 'ARTWORK')
	NormalTexture:SetWidth(12)
	NormalTexture:SetHeight(14)
	NormalTexture:SetPoint('TOPLEFT', 10.5, -8.5)
	NormalTexture:SetTexture('Interface\\RAIDFRAME\\Raid-Icon-DebuffCurse')
	NormalTexture:SetTexCoord(2/16, 14/16, 1/16, 15/16)
	MinimapButton:SetNormalTexture(NormalTexture)

	local PushedTexture = MinimapButton:CreateTexture(nil, 'ARTWORK')
	PushedTexture:SetWidth(10)
	PushedTexture:SetHeight(12)
	PushedTexture:SetPoint('TOPLEFT', 11.5, -9.5)
	PushedTexture:SetTexture('Interface\\RAIDFRAME\\Raid-Icon-DebuffCurse')
	PushedTexture:SetTexCoord(2/16, 14/16, 1/16, 15/16)
	MinimapButton:SetPushedTexture(PushedTexture)

	local HighlightTexture = MinimapButton:CreateTexture(nil, 'ARTWORK')
	HighlightTexture:SetPoint('TOPLEFT', 0, 0)
	HighlightTexture:SetPoint('BOTTOMRIGHT', 0, 0)
	HighlightTexture:SetTexture('Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight')
	MinimapButton:SetHighlightTexture(HighlightTexture)

	MinimapButton:SetScript('OnEnter', function(self)
		GameTooltip:SetOwner(self, 'ANCHOR_RIGHT')
		GameTooltip:AddLine('|cff00ff00bBars|r')
		GameTooltip:Show()
	end)
	MinimapButton:SetScript('OnLeave', function(self) GameTooltip:Hide() end)
	MinimapButton:SetScript('OnClick', function(self, button)
		self:UnlockHighlight()
		if IsShiftKeyDown() then
			SlashCmdList['Bars']('bind')
		elseif not IsModifierKeyDown() then
			if (button == 'LeftButton') then
				SlashCmdList['Bars']('')
			elseif (button == 'RightButton') then
				ToggleDropDownMenu(1, nil, bBarsDropDown, self, -0, -0)
				GameTooltip:SetOwner(self, 'ANCHOR_BOTTOMLEFT')
			end
		end
	end)
	MinimapButton:SetScript('OnDragStart', function(self) self:LockHighlight() self:SetScript('OnUpdate', DragMinimapButton) end)
	MinimapButton:SetScript('OnDragStop', function(self) self:SetScript('OnUpdate', nil) self:UnlockHighlight() end)

	MoveMinimapButton()
end

bBars:RegisterEvent('PLAYER_TALENT_UPDATE')
bBars:RegisterEvent('PLAYER_ENTERING_WORLD')
bBars:RegisterEvent('ADDON_LOADED')
bBars:SetScript('OnEvent', function(self, event, addon, ...)
	if LBF then
		LBFGroup = LBFGroup or LBF:Group(addonName)
		LBFGroup:Skin(BarsDB.lbfSkin or "Blizzard", BarsDB.lbfGloss or .4, BarsDB.lbfBackdrop, BarsDB.lbfColors)
		LBF:RegisterSkinCallback(addonName, function(a, SkinID, Gloss, Backdrop, Group, Button, Colors) 
			BarsDB.lbfSkin = SkinID
			BarsDB.lbfGloss = Gloss
			BarsDB.lbfBackdrop = Backdrop
			BarsDB.lbfColors = Colors
		end, "1")
	end

	if BarsDB == nil then BarsDB = {} end
	if BarsDB.tex == nil then BarsDB.tex = 'Interface\\Addons\\'..addonName..'\\border' end
	if BarsDB.keybindings == nil then BarsDB.keybindings = 1 end
	if BarsDB.macroses == nil then BarsDB.macroses = 1 end
	if BarsDB.minimapPos == nil then BarsDB.minimapPos = 0 end

	if (event=='ADDON_LOADED' and addon == addonName) or event == 'PLAYER_ENTERING_WORLD' or event=='PLAYER_TALENT_UPDATE' then
		bBars.HideBlizzard()
		
		local _,class = UnitClass('player')
		
		for i=1,8 do 
			bBars.MakeActionButtonsFrame('bMultiBar'..i, i) 
		end
		
		if (class ~= 'MAGE' and class ~= 'SHAMAN') then bBars.MakeShapeShiftFrame() end
		
		bBars.MakeTotemFrame()
		bBars.MakeMicroMenuFrame()
		bBars.MakePetFrame()
		bBars.MakeBagsFrame()
		bBars.MakeVehicleFrame()
		bBars.MakeExtraBarFrame()
		bBars.UpdateAll()
		
		bBars.CreateMinimapButton()
	end
end)

bBars.ConfigBars = function(isConfig)
	if InCombatLockdown() or UnitAffectingCombat('player') then return end
	if isConfig == true then
		for i, frm in pairs(bBars.frames) do
			frm:Show()
			frm:EnableMouseWheel(1)
			frm:SetBackdrop({ bgFile = 'Interface\\Tooltips\\UI-Tooltip-Background', })
			frm:SetBackdropColor(1, 1, 1)
			if BarsDB[frm:GetName()].hide then frm:SetAlpha(.3) else frm:SetAlpha(1) end
			
			frm:SetScript('OnEnter', function(self) 
				GameTooltip:ClearLines() 
				GameTooltip:SetOwner(self, ANCHOR_TOPRIGHT) 
				GameTooltip:AddLine(self:GetName()) GameTooltip:AddLine('|cff00ddaashift + mousewheel to scale bar|r')
				GameTooltip:AddLine('|cff00ddaaalt + mousewheel to change buttons padding|r')
				GameTooltip:AddLine('|cff00ddaamousewheel to change columns|r')
				GameTooltip:Show() 
			end)
			frm:SetScript('OnLeave', function() GameTooltip:Hide() end)
			
			for j,v in pairs(frm.buttons) do
				v:SetFrameLevel(frm:GetFrameLevel()-1)
				v:EnableMouse(false)
			end
			frm:EnableMouse(true)
			frm:SetScript('OnMouseDown', function(self, buttonkey) 
				if buttonkey == 'LeftButton' and not IsModifierKeyDown() then
					self:StartMoving()
				end
			end)
			frm:SetMovable(true)
			frm:SetResizable(true)
			frm:SetClampedToScreen(true)
			
			frm:SetScript('OnMouseUp', function(self, buttonkey)
				if buttonkey == 'LeftButton' and not IsModifierKeyDown() then
					self:StopMovingOrSizing()
					for i,v in pairs(bBars.frames) do
						if v ~= self then
							bBars.Stick(self, v, 16)
						end
					end
					
					local point, relativeTo, relativePoint, x, y = self:GetPoint()
					if relativeTo then
						BarsDB[self:GetName()].setPoint = { point, relativeTo:GetName(), relativePoint, x, y }
					else
						BarsDB[self:GetName()].setPoint = { point, 'UIParent', relativePoint, x, y }
					end
				else
					if not BarsDB[self:GetName()] then BarsDB[self:GetName()] = {} end
					if BarsDB[self:GetName()].hide then
						BarsDB[self:GetName()].hide = false
						self:SetAlpha(1)
					else
						BarsDB[self:GetName()].hide = true
						self:SetAlpha(.3)
					end
				end
			end)
		end
	else
		for i,frm in pairs(bBars.frames) do
			frm:SetBackdrop(nil)
			frm:EnableMouseWheel(0)
			frm:SetScript('OnEnter', nil)
			frm:SetScript('OnLeave', nil)
			
			for j,v in pairs(frm.buttons) do
				v:SetFrameLevel(frm:GetFrameLevel()+1)
				v:EnableMouse(true)
			end
			
			frm:SetMovable(false)
			frm:SetResizable(false)
			frm:EnableMouse(false)
			frm:SetScript('OnMouseDown', nil)
			frm:SetScript('OnMouseUp', nil)
			if not BarsDB[frm:GetName()] then BarsDB[frm:GetName()] = {} end
			if BarsDB[frm:GetName()].hide then frm:Hide() else frm:Show() end
		end
	end
end

-- setup slash command
SLASH_Bars1 = '/bbars';
SLASH_Bars2 = '/bb';
SlashCmdList['Bars'] = function(cmd)
	if InCombatLockdown() or UnitAffectingCombat('player') then return end
	if (cmd:lower() == 'reset') then
		BarsDB = {}
		ReloadUI()
	elseif (cmd:lower() == 'bind') then
		bBars.config = false
		bBars.ConfigBars(false)
		bBars.HoverBind() 
	else
		bBars.config = not bBars.config
		bBars.ConfigBars(bBars.config)
	end
end